/**
 * @version $Id: Transform.g 1614 2011-07-10 19:05:43Z guard $
 */
grammar Transform;

@header {
    package com.rempl.impl.model;
    import com.rempl.api.Element;
    import com.ymock.util.RuntimeProblem;
    import com.rempl.impl.ElementImpl;
    import java.util.ArrayList;
    import java.util.Collection;
    import java.util.Map;
    import java.util.HashMap;
}

@lexer::header {
    package com.rempl.impl.model;
    import com.ymock.util.RuntimeProblem;
}

@lexer::members {
    private boolean textMode = false;
    @Override
    public void emitErrorMessage(String msg) {
        throw RuntimeProblem.make(msg);
    }
}

@parser::members {
    @Override
    public void emitErrorMessage(String msg) {
        throw RuntimeProblem.make(msg);
    }
}

/* a:Class { name: "some name"; }; */
elements returns [Collection<Element> elements]
    @init{ $elements = new ArrayList<Element>(); }
    :
    (
        element
        { $elements.add($element.element); }
    )*
    EOF
    ;

/* a:Class { name: "some name"; }; */
element returns [Element element]
    :
    ( id=NAME )?
    ':'
    type=NAME
    '{'
    { $element = new ElementImpl($id.text, $type.text); }
    (
        slot=NAME
        ':'
        QUOTE
        TEXT
        QUOTE
        ';'
        { $element.put($slot.text, $TEXT.text); }
    )*
    '}'
    ';'
    ;

QUOTE: '"' { textMode = !textMode; };
TEXT: {textMode}?=> (~'"')*;

NAME: LETTER ( LETTER | NUMBER )*;
fragment LETTER: 'a'..'z' | 'A'..'Z';
fragment NUMBER: '0'..'9';
SPACE
    :
    ( ' ' | '\t' | '\n' | '\r' )+
    { skip(); }
    ;
