/**
 * @version $Id: RemplFactoryTest.java 1614 2011-07-10 19:05:43Z guard $
 */
package com.rempl.api;

import com.ymock.util.Logger;
import org.junit.*;
import static org.junit.Assert.*;
import com.rempl.tk.*;
import com.rempl.impl.*;

public class RemplFactoryTest {

    @Test
    public void testSurfaceArea() throws Exception {
        Reflector.start()
            .interfaceExists("com.rempl.api.RemplFactory")
                .methodExists("setLoader(com.rempl.api.Loader)")
                    .back() // to class
                .methodExists("makeRempler(com.rempl.api.ROM)")
                    .returns("com.rempl.api.Rempler")
                    .back() // to class
                    ;
    }

    // @Test
    // public void testCreatesNewRempler() throws Exception {
    //     RemplFactory factory = Rempl.getFactory();
    //     factory.setLoader(new LoaderImpl());
    //     ROM rom = new ROM(ResourceLoader.find("this-project.xml"));
    //     Rempler rempler = factory.makeRempler(rom);
    //     assertNotNull(rempler);
    // }

    @Test
    public void testValidatesLoadedConfiguration() throws Exception {
        RemplFactory factory = Rempl.getFactory();
        ROM rom = new ROM(ResourceLoader.find("this-project.xml"));
        Rempler rempler = factory.makeRempler(rom);
        Logger.debug(this, "config:\n%s", rempler.configuration().toString());
        assertEquals(".", rempler.configuration().get("/*/sources/directory/text()"));
    }

    @Test
    public void testSetsAndGetsLoader() throws Exception {
        RemplFactory factory = Rempl.getFactory();
        Loader loader = new LoaderImpl();
        factory.setLoader(loader);
        assertEquals(loader, factory.getLoader());
    }

}
