/**
 * @version $Id: LoaderImpl.java 1614 2011-07-10 19:05:43Z guard $
 */
package com.rempl.impl;

import com.rempl.api.Artifact;
import com.rempl.api.Loader;
import com.rempl.api.LoadingException;
import com.rempl.api.ROM;
import com.rempl.api.ROMException;
import com.rempl.tk.ResourceLoader;
import com.ymock.util.Logger;

public class LoaderImpl implements Loader {

    @Override
    public void resolve(final Artifact artifact) throws LoadingException {
        Logger.trace(this, "resolving %s", artifact.toString());
        // nothing to do
    }

    @Override
    public ROM load(final Artifact artifact) throws LoadingException {
        Logger.trace(this, "loading %s", artifact.toString());
        ROM rom;
        try {
            rom = new ROM(ResourceLoader.find("reader.xml"));
        } catch (java.io.FileNotFoundException ex) {
            throw new LoadingException(ex);
        } catch (ROMException ex) {
            throw new LoadingException(ex);
        }
        return rom;
    }

    @Override
    public Class forName(final String name) throws LoadingException {
        try {
            return this.getClass().forName(name);
        } catch (ClassNotFoundException ex) {
            throw new LoadingException(ex);
        }
    }

}
