/**
 * @version $Id: ReaderImpl.java 1614 2011-07-10 19:05:43Z guard $
 */
package com.rempl.impl;

import com.rempl.api.*;
import java.io.File;

import com.ymock.util.Logger;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.filefilter.*;
import java.util.Iterator;

public class ReaderImpl implements Reader {

    private Rempler rempler = null;

    @Override
    public void setRempler(final Rempler rpr) {
        this.rempler = rpr;
    }

    @Override
    public boolean read(final Model model) throws java.io.IOException {
        Logger.debug(this, "Reader %s started", this.getClass().getName());
        File dir = new File(this.rempler.configuration().get("/*/sources/directory/text()"));
        String excludes = this.rempler.configuration().get("/*/sources/excludes/exclude/text()");
        String includes = this.rempler.configuration().get("/*/sources/includes/include/text()");
        Iterator<File> files = FileUtils.iterateFiles(
            dir,
            new AndFileFilter(
                new WildcardFileFilter(includes),
                new NotFileFilter(new WildcardFileFilter(excludes))
            ),
            DirectoryFileFilter.INSTANCE
        );
        while (files.hasNext()) {
            model.transform(
                String.format(
                    ":Artifact { filename: \"%s\"; };",
                    files.next().getPath()
                )
            );
        }
        return false;
    }

}
