/**
 * @version $Id: ReporterImpl.java 1614 2011-07-10 19:05:43Z guard $
 */
package com.rempl.impl;

import com.rempl.api.*;
import java.io.File;
import java.io.IOException;
import java.util.Collection;

import com.ymock.util.Logger;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.StringUtils;

public class ReporterImpl implements Reporter {

    private Rempler rempler = null;

    @Override
    public void setRempler(final Rempler rpr) {
        this.rempler = rpr;
    }

    @Override
    public void report(final Model model, final File dir) throws IOException {
        Logger.debug(
            this,
            "Reporter %s started at %s (with %s)",
            this.getClass().getName(),
            dir,
            this.rempler.getClass().getName()
        );
        Collection<Element> artifacts = model.query("context Artifact inv: true");
        for (Element artifact : artifacts) {
            File html = new File(
                dir + File.separator
                + StringUtils.replaceChars(artifact.get("filename"),
                    File.separator + ".", "--")
                + ".html"
            );
            if (!html.exists()) {
                if (html.createNewFile()) {
                    Logger.debug(this, "created file %s", html);
                }
            }
            FileUtils.writeStringToFile(
                html,
                FileUtils.readFileToString(new File(artifact.get("filename")))
            );
        }
    }

}
